# Auto-Generated Swagger Bindings to `1Gb`

The library in `lib` provides auto-generated-from-Swagger bindings to the 1Gb API.

## Installation

Installation follows the standard approach to installing Stack-based projects.

1. Install the [Haskell `stack` tool](http://docs.haskellstack.org/en/stable/README).
2. Run `stack install` to install this package.

## Main Interface

The main interface to this library is in the `1Gb.API` module, which exports the 1GbBackend type. The 1GbBackend
type can be used to create and define servers and clients for the API.

## Creating a Client

A client can be created via the `create1GbClient` function, which, if provided with a hostname and a port, will generate
a client that can be used to access the API if it is being served at that hostname / port combination. For example, if
`localhost:8080` is serving the 1Gb API, you can write:

```haskell
{-# LANGUAGE RecordWildCards #-}

import 1Gb.API

main :: IO ()
main = do
  1GbBackend{..} <- create1GbClient (ServerConfig "localhost" 8080)
  -- Any 1Gb API call can go here.
  return ()
```

## Creating a Server

In order to create a server, you must use the `run1GbServer` function. However, you unlike the client, in which case you *got* a `1GbBackend`
from the library, you must instead *provide* a `1GbBackend`. For example, if you have defined handler functions for all the
functions in `1Gb.Handlers`, you can write:

```haskell
{-# LANGUAGE RecordWildCards #-}

import 1Gb.API

-- A module you wrote yourself, containing all handlers needed for the 1GbBackend type.
import 1Gb.Handlers

-- Run a 1Gb server on localhost:8080
main :: IO ()
main = do
  let server = 1GbBackend{..}
  run1GbServer (ServerConfig "localhost" 8080) server
```

You could use `optparse-applicative` or a similar library to read the host and port from command-line arguments:
```
{-# LANGUAGE RecordWildCards #-}

module Main (main) where

import 1Gb.API (run1GbServer, 1GbBackend(..), ServerConfig(..))

import Control.Applicative ((<$>), (<*>))
import Options.Applicative (execParser, option, str, auto, long, metavar, help)

main :: IO ()
main = do
  config <- parseArguments
  run1GbServer config 1GbBackend{}

-- | Parse host and port from the command line arguments.
parseArguments :: IO ServerConfig
parseArguments =
  execParser $
    ServerConfig
      <$> option str  (long "host" <> metavar "HOST" <> help "Host to serve on")
      <*> option auto (long "port" <> metavar "PORT" <> help "Port to serve on")
```
