{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# OPTIONS_GHC -fno-warn-unused-binds -fno-warn-unused-imports #-}

module 1Gb.Types (
      (..),
    Inline_response_200 (..),
    Inline_response_200_1 (..),
    Inline_response_200_10 (..),
    Inline_response_200_11 (..),
    Inline_response_200_12 (..),
    Inline_response_200_13 (..),
    Inline_response_200_14 (..),
    Inline_response_200_2 (..),
    Inline_response_200_3 (..),
    Inline_response_200_4 (..),
    Inline_response_200_5 (..),
    Inline_response_200_6 (..),
    Inline_response_200_7 (..),
    Inline_response_200_8 (..),
    Inline_response_200_9 (..),
    ) where

import Data.List (stripPrefix)
import Data.Maybe (fromMaybe)
import Data.Aeson (Value, FromJSON(..), ToJSON(..), genericToJSON, genericParseJSON)
import Data.Aeson.Types (Options(..), defaultOptions)
import Data.Text (Text)
import qualified Data.Text as T
import qualified Data.Map as Map
import GHC.Generics (Generic)
import Data.Function ((&))


-- | 
data   =  
    {  Mail :: Text -- ^ Ограничение на количество почтовых ящиков. '-' означает отсутствие лимита.
    ,  Website :: Text -- ^ Ограничение на количество сайтов. '-' означает отсутствие лимита.
    ,  Mysql :: Bool -- ^ MySQL разрешен, если true.
    ,  Size :: Text -- ^ Ограничение на размер дискового пространства. '-' означает отсутствие лимита.
    ,  Mssql :: Bool -- ^ MSSQL разрешен, если true.
    ,  DynamicContent :: Bool -- ^ CGI и PHP скрипты разрешены, если true.
    ,  PhpExec :: Bool -- ^ Функция exec() в PHP разрешена, если true.
    ,  Ftp2 :: Text -- ^ Ограничение на количество дополнительных FTP логинов. '-' означает отсутствие лимита.
    } deriving (Show, Eq, Generic)

instance FromJSON   where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True " ")
instance ToJSON   where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False " ")

-- | 
data Inline_response_200 = Inline_response_200
    { inlineResponse200NegativeBalanceDays :: Int -- ^ Планируемое количество дней до наступления негативного баланса
    , inlineResponse200NegativeBalanceDaysLic :: Int -- ^ Планируемое количество дней до наступления негативного баланса по аккаунту лицензий
    , inlineResponse200LastMonthDebtSum :: Double -- ^ 
    , inlineResponse200LastMonthDebtSum2 :: Double -- ^ 
    , inlineResponse200BlockDate :: Text -- ^ Дата блокировки аккаунта
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse200")
instance ToJSON Inline_response_200 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse200")

-- | 
data Inline_response_200_1 = Inline_response_200_1
    { inlineResponse2001Id :: Int -- ^ Идентификатор аккаунта
    , inlineResponse2001Description :: Text -- ^ Описание аккаунта
    , inlineResponse2001BillingGroupId :: Int -- ^ Идентификатор тарифной группы
    , inlineResponse2001Blocked :: Text -- ^ Аккаунт заблокирован, если true
    , inlineResponse2001BlockedDate :: Text -- ^ Дата блокировки
    , inlineResponse2001BlockedReason :: Text -- ^ Причина блокировки
    , inlineResponse2001CreditLimit :: Double -- ^ Ограничение суммы на работу в аванс
    , inlineResponse2001PlanId :: Int -- ^ Идентификатор тарифа
    , inlineResponse2001PeriodId :: Int -- ^ Идентификатор тарифа (периода)
    , inlineResponse2001ContractType :: Int -- ^ Тип договора
    , inlineResponse2001ClientId :: Int -- ^ 
    , inlineResponse2001ClientLogin :: Text -- ^ Логин клиента
    , inlineResponse2001ContractId :: Text -- ^ Номер договора
    , inlineResponse2001NameRus :: Text -- ^ Имя клиента на русском
    , inlineResponse2001NameEng :: Text -- ^ Имя клиента на английском
    , inlineResponse2001Email :: Text -- ^ E-mail клиент
    , inlineResponse2001StatSites :: Int -- ^ Количество созданных сайтов
    , inlineResponse2001StatSizeMb :: Int -- ^ Используемое дисковое пространство
    , inlineResponse2001StatEmails :: Int -- ^ Количество созданных почтовых ящиков
    , inlineResponse2001StatMysqls :: Int -- ^ Количество баз данных MySQL
    , inlineResponse2001StatTech :: Int -- ^ 
    , inlineResponse2001StatNicd :: Int -- ^ 
    , inlineResponse2001StatAccessDynamic :: Int -- ^ 
    , inlineResponse2001StatAccessStatic :: Int -- ^ 
    , inlineResponse2001StatAccessTraffic :: Int -- ^ 
    , inlineResponse2001StatPaidTotal :: Int -- ^ 
    , inlineResponse2001StatVdsSize :: Int -- ^ Размер дисков VDS
    , inlineResponse2001PlanName :: Text -- ^ Название тарифного плана
    , inlineResponse2001PeriodMonths :: Int -- ^ Количество месяцев в оплаченном периоде
    , inlineResponse2001PeriodPrice :: Double -- ^ Стоимость оплаченного периода
    , inlineResponse2001Expires :: Text -- ^ 
    , inlineResponse2001ExternalCurrencySpelledPrefix :: Text -- ^ Префикс для вывода текущей валюты хостинга (например, в строке '$100' префиксом является '$')
    , inlineResponse2001ExternalCurrencySpelledSuffix :: Text -- ^ Суффикс для вывода текущей валюты хостинга (например, в строке '100 руб.' суффиксом является ' руб.'
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_1 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse2001")
instance ToJSON Inline_response_200_1 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse2001")

-- | 
data Inline_response_200_10 = Inline_response_200_10
    { inlineResponse20010Id :: Int -- ^ Идентификатор записи
    , inlineResponse20010Datetime :: Text -- ^ Дата и время создания записи
    , inlineResponse20010Description :: Text -- ^ Тело сообщения (с HTML-тэгами)
    , inlineResponse20010DescriptionPlain :: Text -- ^ Тело сообщения (без тэгов)
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_10 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse20010")
instance ToJSON Inline_response_200_10 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse20010")

-- | 
data Inline_response_200_11 = Inline_response_200_11
    { inlineResponse20011Ip :: Text -- ^ IP-адрес
    , inlineResponse20011VdsId :: Int -- ^ идентификатор VDS
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_11 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse20011")
instance ToJSON Inline_response_200_11 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse20011")

-- | 
data Inline_response_200_12 = Inline_response_200_12
    { inlineResponse20012Id :: Int -- ^ идентификатор VDS
    , inlineResponse20012Deleted :: Bool -- ^ VDS удалён если true
    , inlineResponse20012Online :: Bool -- ^ VDS работает нормально если true
    , inlineResponse20012Stopped :: Bool -- ^ VDS остановлен если true
    , inlineResponse20012Pwd :: Text -- ^ изначальный пароль администратора или root
    , inlineResponse20012Template :: Text -- ^ шаблон, на основе которого был создан VDS
    , inlineResponse20012TypeFull :: Text -- ^ полное описание типа VDS
    , inlineResponse20012PhysicalMac :: Text -- ^ MAC-адрес VDS
    , inlineResponse20012Type_ :: Text -- ^ тип VDS
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_12 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse20012")
instance ToJSON Inline_response_200_12 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse20012")

-- | 
data Inline_response_200_13 = Inline_response_200_13
    { inlineResponse20013Type_ :: Text -- ^ Тип VDS, для которого применим шаблон. Принимает значения 'hv' и 'vz'
    , inlineResponse20013Template :: Text -- ^ Имя шаблона
    , inlineResponse20013Popularity :: Int -- ^ Популярность
    , inlineResponse20013ActualTemplate :: Int -- ^ Актуальность шаблона. 1 = шаблон актуален
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_13 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse20013")
instance ToJSON Inline_response_200_13 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse20013")

-- | 
data Inline_response_200_14 = Inline_response_200_14
    { inlineResponse20014Id :: Int -- ^ 
    , inlineResponse20014Status :: Text -- ^ 
    , inlineResponse20014Unmovable :: Text -- ^ 
    , inlineResponse20014Online :: Text -- ^ Включен (активен), если true.
    , inlineResponse20014Deleted :: Text -- ^ Удален, если true. Данные могут сохраняться.
    , inlineResponse20014DeletedAuto :: Text -- ^ Удален, если true. Данные могут сохраняться.
    , inlineResponse20014DeletedDump :: Text -- ^ 
    , inlineResponse20014UserId :: Text -- ^ 
    , inlineResponse20014FtpId :: Text -- ^ 
    , inlineResponse20014DnsId :: Text -- ^ 
    , inlineResponse20014IisId :: Text -- ^ 
    , inlineResponse20014IisBinding :: Text -- ^ 
    , inlineResponse20014IisPath :: Text -- ^ 
    , inlineResponse20014IisComments :: Text -- ^ Уникальное строковое имя сайта (ID).
    , inlineResponse20014Memo :: Text -- ^ 
    , inlineResponse20014DateReg :: Text -- ^ Дата создания.
    , inlineResponse20014Server :: Text -- ^ Тип веб-сервера.
    , inlineResponse20014ServerBak :: Text -- ^ 
    , inlineResponse20014ServerAux :: Text -- ^ 
    , inlineResponse20014ServerTransition :: Text -- ^ Тип сервера недавно изменялся, если true.
    , inlineResponse20014ServerTransitionDtc :: Text -- ^ 
    , inlineResponse20014BlockTransfer :: Text -- ^ 
    , inlineResponse20014ServerChangedTime :: Text -- ^ 
    , inlineResponse20014SizeAmount :: Text -- ^ Размер веб-сайта - объем (Кб).
    , inlineResponse20014SizeFileCount :: Text -- ^ Размер веб-сайта - кол-во файлов.
    , inlineResponse20014SizeFileCountLimit :: Text -- ^ 
    , inlineResponse20014SizeDate :: Text -- ^ Размер веб-сайта - дата замера.
    , inlineResponse20014SizePriorityScan :: Text -- ^ 
    , inlineResponse20014CopyLogs :: Text -- ^ 
    , inlineResponse20014ContentComments :: Text -- ^ 
    , inlineResponse20014ContentCommentsVerbose :: Text -- ^ 
    , inlineResponse20014MetaSaveCount :: Text -- ^ 
    , inlineResponse20014BaseFolder :: Text -- ^ 
    , inlineResponse20014VirtualhostConf :: Text -- ^ 
    , inlineResponse20014VirtualhostServer :: Text -- ^ 
    , inlineResponse20014VirtualhostServerConf :: Text -- ^ 
    , inlineResponse20014LiveDayCount :: Text -- ^ 
    , inlineResponse20014ScanDate :: Text -- ^ 
    , inlineResponse20014GlobalTransferCount :: Text -- ^ 
    , inlineResponse20014NetLimitFile :: Text -- ^ 
    , inlineResponse20014NetLimitDenyFromIp :: Text -- ^ 
    , inlineResponse20014NetLimitDenyFromAgent :: Text -- ^ 
    , inlineResponse20014ApachePhpPooled :: Text -- ^ 
    , inlineResponse20014ApachePhpPooledExt :: Text -- ^ 
    , inlineResponse20014ApachePhpPooledExtAuto :: Text -- ^ 
    , inlineResponse20014ApachePhpPool1Only :: Text -- ^ 
    , inlineResponse20014ApachePhpPool5Only :: Text -- ^ 
    , inlineResponse20014ApacheSsi :: Text -- ^ 
    , inlineResponse20014BypassSecurity :: Text -- ^ 
    , inlineResponse20014FlagGenericExec :: Text -- ^ 
    , inlineResponse20014FlagNoWww :: Text -- ^ 
    , inlineResponse20014BaseFolderSuffix :: Text -- ^ 
    , inlineResponse20014FeedbackSpeed :: Text -- ^ 
    , inlineResponse20014FeedbackSpeedDtc :: Text -- ^ 
    , inlineResponse20014FeedbackSpeedFeedback :: Text -- ^ 
    , inlineResponse20014UnixPathOnWindows :: Text -- ^ 
    , inlineResponse20014FtpIpfilter :: Text -- ^ Ограничение по IP адресам - FTP доступ.
    , inlineResponse20014SshIpfilter :: Text -- ^ Ограничение по IP адресам - SSH доступ.
    , inlineResponse20014L3dAuto :: Text -- ^ 
    , inlineResponse20014AwstatsPrimaryDomain :: Text -- ^ 
    , inlineResponse20014SharepointMode :: Text -- ^ 
    , inlineResponse20014SharepointModePending :: Text -- ^ 
    , inlineResponse20014ApacheGenericPoolPort :: Text -- ^ 
    , inlineResponse20014MongrelEnvironment :: Text -- ^ 
    , inlineResponse20014FlagFree :: Text -- ^ 
    , inlineResponse20014RtmScanDate :: Text -- ^ 
    , inlineResponse20014AnalyzeAnalog :: Text -- ^ 
    , inlineResponse20014CpuDetailsEnabled :: Text -- ^ Включен режим предоставления детализации процессорной нагрузки.
    , inlineResponse20014ContentModeratedStatus :: Text -- ^ 
    , inlineResponse20014ContentModeratedDate :: Text -- ^ 
    , inlineResponse20014HttpFrontendIp :: Text -- ^ 
    , inlineResponse20014HttpFrontendIpTransition :: Text -- ^ 
    , inlineResponse20014CpuLimitExceededDate :: Text -- ^ Дата последнего превышения процессорной нагрузки.
    , inlineResponse20014AufsTemplate :: Text -- ^ Признак сайта-конструктора.
    , inlineResponse20014OptionsAutolimit :: Text -- ^ 
    , inlineResponse20014IisCreationCommands :: Text -- ^ Версия ASP.NET, если отлична от 2.0.
    , inlineResponse20014IisCreationCommandsUnix :: Text -- ^ 
    , inlineResponse20014ThumbDate :: Text -- ^ 
    , inlineResponse20014ThumbFailed :: Text -- ^ 
    , inlineResponse20014BackupStatDate :: Text -- ^ 
    , inlineResponse20014BackupDate :: Text -- ^ Дата пофайловой резервной копии.
    , inlineResponse20014DetectedPackages :: Text -- ^ 
    , inlineResponse20014StatSitePower :: Text -- ^ 
    , inlineResponse20014SmtpFrom :: Text -- ^ 
    , inlineResponse20014SuperBackupDate :: Text -- ^ 
    , inlineResponse20014BackupDeltaStatDate :: Text -- ^ 
    , inlineResponse20014BackupDeltaDate :: Text -- ^ Дата архивной резервной копии.
    , inlineResponse20014BackupDeltaDesc :: Text -- ^ Содержимое архивной резервной копии.
    , inlineResponse20014AltDocrootServer :: Text -- ^ 
    , inlineResponse20014AltDocrootPath :: Text -- ^ 
    , inlineResponse20014AltDocrootStatus :: Text -- ^ 
    , inlineResponse20014AltDocrootStatusCnt :: Text -- ^ 
    , inlineResponse20014AltDocrootStatusDate :: Text -- ^ 
    , inlineResponse20014BindDtc :: Text -- ^ Последнее изменение привязок доменов для сайта.
    , inlineResponse20014BackupSpecialMode :: Text -- ^ 
    , inlineResponse20014SizeCheckProblem :: Text -- ^ 
    , inlineResponse20014WpbDomain :: Text -- ^ 
    , inlineResponse20014WpbUuid :: Text -- ^ Для сайта включен конструктор Parallels WPB.
    , inlineResponse20014WpbStatus :: Text -- ^ 
    , inlineResponse20014AdminProtection :: Text -- ^ 
    , inlineResponse20014SizeComments :: Text -- ^ 
    , inlineResponse20014AltDocrootSsdReq :: Text -- ^ 
    , inlineResponse20014MailLimit :: Text -- ^ 
    , inlineResponse20014MailAccept :: Text -- ^ 
    , inlineResponse20014MailDrop :: Text -- ^ 
    , inlineResponse20014FtpName :: Text -- ^ FTP/SSH/SCP/SFTP логин.
    , inlineResponse20014FtpPwd :: Text -- ^ FTP/SSH/SCP/SFTP пароль.
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_14 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse20014")
instance ToJSON Inline_response_200_14 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse20014")

-- | 
data Inline_response_200_2 = Inline_response_200_2
    { inlineResponse2002Id :: Int -- ^ идентификатор аккаунта
    , inlineResponse2002Name :: Text -- ^ логин
    , inlineResponse2002Server :: Text -- ^ идентификатор сервера. Если равен или больше 10000, то это Postgres. Иначе MySQL
    , inlineResponse2002Pwd :: Text -- ^ пароль
    , inlineResponse2002UrlSuffix :: Text -- ^ суффикс домена сервера
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_2 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse2002")
instance ToJSON Inline_response_200_2 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse2002")

-- | 
data Inline_response_200_3 = Inline_response_200_3
    { inlineResponse2003Id :: Int -- ^ идентификатор домена
    , inlineResponse2003IisId :: Int -- ^ идентификатор связанной записи IIS
    , inlineResponse2003Online :: Bool -- ^ домен работает, если true
    , inlineResponse2003FullDomainName :: Text -- ^ полное имя домена
    , inlineResponse2003FullDomainNameLocal :: Text -- ^ 
    , inlineResponse2003Addr1 :: Text -- ^ 
    , inlineResponse2003Zone :: Text -- ^ зона домена
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_3 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse2003")
instance ToJSON Inline_response_200_3 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse2003")

-- | 
data Inline_response_200_4 = Inline_response_200_4
    { inlineResponse2004DateUpdated :: Text -- ^ Дата последнего обновления домена
    , inlineResponse2004RecordCreated :: Text -- ^ Дата создания записи
    , inlineResponse2004SubjectContract :: Text -- ^ 
    , inlineResponse2004EndDate :: Text -- ^ 
    , inlineResponse2004PayedTill :: Text -- ^ Дата, до которой оплачен домен
    , inlineResponse2004ObjectState :: Text -- ^ 
    , inlineResponse2004DomainAddr :: Text -- ^ Имя домена
    , inlineResponse2004Nservers :: Text -- ^ Сервера имён домена
    , inlineResponse2004ExpiresCountdown :: Int -- ^ Количество дней до окончания срока действия домена
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_4 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse2004")
instance ToJSON Inline_response_200_4 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse2004")

-- | 
data Inline_response_200_5 = Inline_response_200_5
    { inlineResponse2005Id :: Int -- ^ идентификатор псевдонима
    , inlineResponse2005Mail :: Text -- ^ почтовый ящик псевдонима
    , inlineResponse2005Alias :: Text -- ^ имя псевдонима
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_5 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse2005")
instance ToJSON Inline_response_200_5 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse2005")

-- | 
data Inline_response_200_6 = Inline_response_200_6
    { inlineResponse2006Id :: Int -- ^ идентификатор ящика
    , inlineResponse2006Status :: Int -- ^ 
    , inlineResponse2006Online :: Bool -- ^ ящик работает, если true
    , inlineResponse2006Mail :: Text -- ^ полный адрес ящика
    , inlineResponse2006MercuryUser :: Text -- ^ имя пользователя для входа в Mercury
    , inlineResponse2006MercuryPwd :: Text -- ^ пароль для входа в Mercury
    , inlineResponse2006SizeAmount :: Int -- ^ текущий размер ящика
    , inlineResponse2006SizeFileCount :: Int -- ^ количество файлов, занятых ящиком
    , inlineResponse2006ArchivedCount :: Int -- ^ 
    , inlineResponse2006ServerPop3 :: Text -- ^ адрес сервера для доступа к ящику по POP3
    , inlineResponse2006ServerSmtp :: Text -- ^ адрес сервера для доступа к ящику по SMTP
    , inlineResponse2006ServerWebmail :: Text -- ^ адрес сервера Webmail для входа в ящик через браузер
    , inlineResponse2006ServerImap :: Text -- ^ адрес сервера для доступа к ящику по IMAP
    , inlineResponse2006Wm1 :: Text -- ^ 
    , inlineResponse2006Wm2 :: Text -- ^ 
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_6 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse2006")
instance ToJSON Inline_response_200_6 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse2006")

-- | 
data Inline_response_200_7 = Inline_response_200_7
    { inlineResponse2007Id :: Int -- ^ идентификатор аккаунта
    , inlineResponse2007Name :: Text -- ^ логин
    , inlineResponse2007Pwd :: Text -- ^ пароль
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_7 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse2007")
instance ToJSON Inline_response_200_7 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse2007")

-- | 
data Inline_response_200_8 = Inline_response_200_8
    { inlineResponse2008Id :: Int -- ^ идентификатор сайта
    , inlineResponse2008Online :: Bool -- ^ сайт работает нормально если true
    , inlineResponse2008FtpId :: Int -- ^ идентификатор связанного аккаунта FTP
    , inlineResponse2008DnsId :: Int -- ^ идентификатор связанной записи DNS
    , inlineResponse2008SizeAmount :: Int -- ^ размер занятого места
    , inlineResponse2008SizeFileCount :: Int -- ^ количество файлов
    , inlineResponse2008SizeFileCountLimit :: Int -- ^ ограничение на количество файлов
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_8 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse2008")
instance ToJSON Inline_response_200_8 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse2008")

-- | 
data Inline_response_200_9 = Inline_response_200_9
    { inlineResponse2009Id :: Int -- ^ идентификатор аккаунта
    , inlineResponse2009Db :: Text -- ^ имя базы данных
    , inlineResponse2009Server :: Text -- ^ адрес сервера
    , inlineResponse2009Name :: Text -- ^ логин
    , inlineResponse2009Pwd :: Text -- ^ пароль
    } deriving (Show, Eq, Generic)

instance FromJSON Inline_response_200_9 where
  parseJSON  = genericParseJSON  (removeFieldLabelPrefix True "inlineResponse2009")
instance ToJSON Inline_response_200_9 where
  toJSON     = genericToJSON     (removeFieldLabelPrefix False "inlineResponse2009")

-- Remove a field label prefix during JSON parsing.
-- Also perform any replacements for special characters.
removeFieldLabelPrefix :: Bool -> String -> Options
removeFieldLabelPrefix forParsing prefix =
  defaultOptions
    { fieldLabelModifier = fromMaybe (error ("did not find prefix " ++ prefix)) . stripPrefix prefix . replaceSpecialChars
    }
  where
    replaceSpecialChars field = foldl (&) field (map mkCharReplacement specialChars)
    specialChars = [("@", "'At"), ("!", "'Exclamation"), ("#", "'Hash"), ("$", "'Dollar"), ("%", "'Percent"), ("&", "'Ampersand"), ("*", "'Star"), ("+", "'Plus"), ("-", "'Dash"), (":", "'Colon"), ("|", "'Pipe"), ("<", "'LessThan"), ("=", "'Equal"), ("^", "'Caret"), (">", "'GreaterThan")]
    mkCharReplacement (replaceStr, searchStr) = T.unpack . replacer (T.pack searchStr) (T.pack replaceStr) . T.pack
    replacer = if forParsing then flip T.replace else T.replace


